﻿Imports GrxCAD.ApplicationServices
Imports GrxCAD.DatabaseServices
Imports GrxCAD.EditorInput
Imports GrxCAD.Geometry
Imports GrxCAD.PlottingServices
Imports GrxCAD.Runtime

Public Class sample : Implements IExtensionApplication
	'初期化処理
	Public Sub Initialize() Implements IExtensionApplication.Initialize
		Dim icEd As Editor = Application.DocumentManager.MdiActiveDocument.Editor
		icEd.WriteMessage($"{vbLf}サンプルの.NETアセンブリをロードしました")
	End Sub

	'解放処理
	Public Sub Terminate() Implements IExtensionApplication.Terminate
	End Sub

	<CommandMethod("PLOTSAMPLE")>
	Public Sub PlotSample()
		Dim icDb As Database = Application.DocumentManager.MdiActiveDocument.Database
		Dim icEd As Editor = Application.DocumentManager.MdiActiveDocument.Editor

		Dim icOpt As PromptSaveFileOptions = New PromptSaveFileOptions(vbLf + "出力先を指定")
		icOpt.Filter = "PDF(*.pdf)|*.pdf"
		icOpt.InitialDirectory = System.Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory)
		Dim icRes As PromptFileNameResult = icEd.GetFileNameForSave(icOpt)
		If icRes.Status <> PromptStatus.OK Then Return

		Using icTrans As Transaction = icDb.TransactionManager.StartTransaction()
			Dim icLayMgr As LayoutManager = LayoutManager.Current
			Dim icLayout As Layout = icTrans.GetObject(icLayMgr.GetLayoutId(icLayMgr.CurrentLayout), OpenMode.ForWrite)
			Dim icPlSetVdr = PlotSettingsValidator.Current
			icPlSetVdr.SetPlotType(icLayout, GrxCAD.DatabaseServices.PlotType.Extents)
			icPlSetVdr.SetUseStandardScale(icLayout, True)
			icPlSetVdr.SetStdScaleType(icLayout, StdScaleType.ScaleToFit)
			icPlSetVdr.SetPlotCentered(icLayout, True)
			icPlSetVdr.SetPlotConfigurationName(icLayout, "DWG To PDF.pc3", Nothing)
			For Each mediaName As String In icPlSetVdr.GetCanonicalMediaNameList(icLayout)
				Dim localName As String = icPlSetVdr.GetLocaleMediaName(icLayout, mediaName)
				If localName = "ISO A4 (297.00 x 210.00 MM)" Then
					icPlSetVdr.SetCanonicalMediaName(icLayout, mediaName)
					Exit For
				End If
			Next
			Using icPlInfo As PlotInfo = New PlotInfo()
				icPlInfo.Layout = icLayout.ObjectId
				icPlInfo.OverrideSettings = icLayout
				Using icPlInfoVdr As PlotInfoValidator = New PlotInfoValidator()
					icPlInfoVdr.MediaMatchingPolicy = MatchingPolicy.MatchEnabled
					icPlInfoVdr.Validate(icPlInfo)
					Using icPlEng As PlotEngine = PlotFactory.CreatePublishEngine()
						Using icPlProgDlg = New PlotProgressDialog(False, 1, True)
							icPlProgDlg.PlotMsgString(PlotMessageIndex.DialogTitle) = "Plot Progress"
							icPlProgDlg.PlotMsgString(PlotMessageIndex.CancelJobButtonMessage) = "Cancel Job"
							icPlProgDlg.PlotMsgString(PlotMessageIndex.CancelSheetButtonMessage) = "Cancel Sheet"
							icPlProgDlg.PlotMsgString(PlotMessageIndex.SheetSetProgressCaption) = "Sheet Set Progress"
							icPlProgDlg.PlotMsgString(PlotMessageIndex.SheetProgressCaption) = "Sheet Progress"
							icPlProgDlg.LowerPlotProgressRange = 0
							icPlProgDlg.UpperPlotProgressRange = 100
							icPlProgDlg.PlotProgressPos = 0
							icPlProgDlg.OnBeginPlot()
							icPlProgDlg.IsVisible = True
							icPlEng.BeginPlot(icPlProgDlg, Nothing)
							icPlEng.BeginDocument(icPlInfo, icDb.OriginalFileName, Nothing, 1, True, icRes.StringResult)
							icPlProgDlg.PlotMsgString(PlotMessageIndex.Status) =
								"Plotting: " + icDb.OriginalFileName + " - " + icLayout.LayoutName
							icPlProgDlg.OnBeginSheet()
							icPlProgDlg.LowerSheetProgressRange = 0
							icPlProgDlg.UpperSheetProgressRange = 100
							icPlProgDlg.SheetProgressPos = 0
							icPlProgDlg.SheetProgressPos = 100
							icPlProgDlg.OnEndSheet()
							icPlEng.EndDocument(Nothing)
							icPlProgDlg.PlotProgressPos = 100
							icPlProgDlg.OnEndPlot()
							icPlEng.EndPlot(Nothing)
						End Using
					End Using
				End Using
			End Using
			icTrans.Commit()
		End Using
	End Sub
End Class
